#!/usr/bin/python
# -*- coding: utf-8 -*- 
#  Bundesliga Live Ticker for Dreambox-Enigma2
#
#  This plugin is licensed under the Creative Commons 
#  Attribution-NonCommercial-ShareAlike 3.0 Unported 
#  License. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
#
#  Alternatively, this plugin may be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.
#
#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially 
#  distributed other than under the conditions noted above.
#
from Components.ActionMap import *
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.config import config

from enigma import ePicLoad
from Tools.LoadPixmap import LoadPixmap
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch

from Components.config import *
from Components.ConfigList import *

from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox

from Screens.ChannelSelection import ChannelSelection
from Screens.InfoBarGenerics import InfoBarSubserviceSelection, InfoBarSeek, InfoBarShowHide
from Screens.MovieSelection import MovieSelection
from Screens.SubservicesQuickzap import SubservicesQuickzap

from Components.PluginComponent import plugins
from Components.Button import Button
from Screens.Screen import Screen
from Plugins.Plugin import PluginDescriptor
from twisted.web.client import getPage
from twisted.web.client import downloadPage
from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, loadPNG, RT_WRAP, eServiceReference, getDesktop, loadJPG
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename
from skin import parseColor
from enigma import eTimer
from datetime import datetime
import re, os, time

def applySkinVars(skin,dict):
	for key in dict.keys():
		try:
				skin = skin.replace('{'+key+'}',dict[key])
		except Exception,e:
				print e,"@key=",key
	return skin

tickerpos_x = 0
tickerpos_y = 620
config.plugins.ticker = ConfigSubsection()
config.plugins.ticker.tickerpos_x = ConfigInteger(tickerpos_x, (-20,100))
config.plugins.ticker.tickerpos_y = ConfigInteger(tickerpos_y, (000,700))
config.plugins.ticker.farbe = ConfigSelection(default="0x00dab329", choices = [("0xCC0000",_("Rot")),("0x00dab329",_("Gelb")),("0xFFFFFF",_("Weiss")),("0x663300",_("Braun")),("0x339966",_("Olive")),("0x666633",_("Grau")),("0x00ffff",_("HellBlau")),("0xccff33",_("HellGrn")),("0xff00ff",_("Lila")),("0x006633",_("Army"))])
config.plugins.ticker.farbe_neu = ConfigSelection(default="0xCC0000", choices = [("0xCC0000",_("Rot")),("0x00dab329",_("Gelb")),("0xFFFFFF",_("Weiss")),("0x663300",_("Braun")),("0x339966",_("Olive")),("0x666633",_("Grau")),("0x00ffff",_("HellBlau")),("0xccff33",_("HellGrn")),("0xff00ff",_("Lila")),("0x006633",_("Army"))])
config.plugins.ticker.live_farbe = ConfigSelection(default="yellow", choices = [("red",_("Rot")),("yellow",_("Gelb")),("blue",_("Blau")),("grey",_("Grau")),("green",_("Gruen")),("darkgrey",_("Dark Grau")),("white",_("Weiss"))])
config.plugins.ticker.live_tore = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.live_karten = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.live_wechsel = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.live_halb = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.refreshtimer = ConfigInteger(10000, (5000,60000))
config.plugins.ticker.hideTimerOnOff = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.hideTimer = ConfigInteger(5000, (1000,60000))
config.plugins.ticker.hidetabTimerOnOff = ConfigSelection(default="1", choices = [("1",_("AN")),("0",_("AUS"))])
config.plugins.ticker.hidetabTimer = ConfigInteger(5000, (1000,60000))
config.plugins.ticker.tabfavverin = ConfigSelection(default="Borussia Dortmund", choices = [("Borussia Dortmund",_("Borussia Dortmund")),("FC Bayern Muenchen",_("FC Bayern Muenchen")),("Borussia M'gladbach",_("Borussia M'gladbach")),("FC Schalke 04",_("FC Schalke 04")),("Bayer 04 Leverkusen",_("Bayer 04 Leverkusen")),("SV Werder Bremen",_("SV Werder Bremen")),("Hannover 96",_("Hannover 96")),("VfB Stuttgart",_("VfB Stuttgart")),("1899 Hoffenheim",_("1899 Hoffenheim")),("1.FC Nuernberg",_("1.FC Nuernberg")),("1.FSV Mainz 05",_("1.FSV Mainz 05")),("Hamburger SV",_("Hamburger SV")),("VfL Wolfsburg",_("VfL Wolfsburg")),("1.FC Koeln",_("1.FC Koeln")),("FC Augsburg",_("FC Augsburg")),("Hertha BSC",_("Hertha BSC")),("1.FC Kaiserslautern",_("1.FC Kaiserslautern")),("SC Freiburg",_("SC Freiburg"))])
config.plugins.ticker.tabfavverinfarbe = ConfigSelection(default="0xCC0000", choices = [("0xCC0000",_("Rot")),("0x00dab329",_("Gelb")),("0xFFFFFF",_("Weiss")),("0x663300",_("Braun")),("0x339966",_("Olive")),("0x666633",_("Grau")),("0x00ffff",_("HellBlau")),("0xccff33",_("HellGrn")),("0xff00ff",_("Lila")),("0x006633",_("Army"))])
config.plugins.ticker.live_spiel = ConfigSelection(default="0x339966", choices = [("0xCC0000",_("Rot")),("0x00dab329",_("Gelb")),("0xFFFFFF",_("Weiss")),("0x663300",_("Braun")),("0x339966",_("Olive")),("0x666633",_("Grau")),("0x00ffff",_("HellBlau")),("0xccff33",_("HellGrn")),("0xff00ff",_("Lila")),("0x006633",_("Army"))])
#config.plugins.ticker.select_liga = ConfigSelection(default="bundesliga-ticker", choices = [("bundesliga-ticker",_("1")),("zweite-liga-ticker",_("2"))])

class tickerlist(MenuList):
	def __init__(self, list):
		MenuList.__init__(self, list, False, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 14))
		self.l.setFont(1, gFont("Regular", 16))
		self.l.setFont(2, gFont("Regular", 18))
		self.l.setFont(3, gFont("Regular", 17))
		self.l.setFont(4, gFont("Regular", 22))
		self.l.setFont(5, gFont("Regular", 24))
		self.l.setFont(6, gFont("Regular", 26))
		self.l.setFont(7, gFont("Regular", 20))
		self.l.setFont(8, gFont("Regular", 19))
		self.l.setItemHeight(60)


class BulitickerConfigScreen(ConfigListScreen,Screen):	
	if getDesktop(0).size().width() == 1280:				
		skin = """
			<screen position="center,center" size="640,450" title="Liga Ticker Setup v1.3" >
				<widget name="config" position="0,0" size="640,400" scrollbarMode="showOnDemand" />
				<widget name="buttonred" position="10,400" size="90,40" backgroundColor="red" valign="center" halign="center" zPosition="1"  foregroundColor="white" font="Regular;18"/>
				<widget name="buttongreen" position="540,400" size="90,40" backgroundColor="green" valign="center" halign="center" zPosition="1"  foregroundColor="white" font="Regular;18"/>
			</screen>"""
				
	def __init__(self, session, args = 0):
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.list.append(getConfigListEntry("Ticker X Position", config.plugins.ticker.tickerpos_x))
		self.list.append(getConfigListEntry("Ticker Y Position", config.plugins.ticker.tickerpos_y))
		#self.list.append(getConfigListEntry(_("Bundesliga:"), config.plugins.ticker.select_liga))
		self.list.append(getConfigListEntry(_("Live Ticker Update Intervall in ms:"), config.plugins.ticker.refreshtimer))
		self.list.append(getConfigListEntry(_("Farbe der Tor Ergebnisse"), config.plugins.ticker.farbe))
		self.list.append(getConfigListEntry(_("Farbe der Tor Ergebnisse bei einem Tor:"), config.plugins.ticker.farbe_neu))
		self.list.append(getConfigListEntry(_("Farbe der Tor Ergebnisse wenn Live:"), config.plugins.ticker.live_spiel))
		self.list.append(getConfigListEntry(_("Farbe des Live Tickers"), config.plugins.ticker.live_farbe))
		self.list.append(getConfigListEntry(_("Live infos: Tore"), config.plugins.ticker.live_tore))
		self.list.append(getConfigListEntry(_("Live infos: Spielerwechsel"), config.plugins.ticker.live_wechsel))
		self.list.append(getConfigListEntry(_("Live infos: Karten"), config.plugins.ticker.live_karten))
		self.list.append(getConfigListEntry(_("Live infos: Pfiff"), config.plugins.ticker.live_halb))
		self.list.append(getConfigListEntry(_("Live Ausblenden:"), config.plugins.ticker.hideTimerOnOff))
		self.list.append(getConfigListEntry(_("Live Ausblenden nach x ms"), config.plugins.ticker.hideTimer))
		self.list.append(getConfigListEntry(_("Tabelle Ausblenden:"), config.plugins.ticker.hidetabTimerOnOff))
		self.list.append(getConfigListEntry(_("Tabelle Ausblenden nach x ms"), config.plugins.ticker.hidetabTimer))
		self.list.append(getConfigListEntry(_("Mein Verein:"), config.plugins.ticker.tabfavverin))
		self.list.append(getConfigListEntry(_("Mein Verein Farbe:"), config.plugins.ticker.tabfavverinfarbe))

		ConfigListScreen.__init__(self, self.list)
		self["buttonred"] = Label(_("cancel"))
		self["buttongreen"] = Label(_("ok"))
		self["setupActions"] = ActionMap(["SetupActions"],
		{
				"green": self.save,
				"red": self.cancel,
				"save": self.save,
				"cancel": self.cancel,
				"ok": self.save,
		}, -2)

	def save(self):
		for x in self["config"].list:
			print "debug:", x[1]
			x[1].save()				
		self.close(True)

	def cancel(self):
		for x in self["config"].list:
			x[1].cancel()
		self.close(False)

class tickertab(Screen):
	if getDesktop(0).size().width() == 1280:
		skin = """
			<screen position="center,center" size="485,400" transparent="0" flags="wfNoBorder" title="Tabelle" >
				<widget name="tickermenulist" position="5,15" size="485,395" transparent="0" scrollbarMode="showNever" />
			</screen>"""

	def __init__(self, session):
		Screen.__init__(self, session)
		self.session = session
		self.hidetab = eTimer()
		self.hidetab.callback.append(self.exit)
		self["actions"] = ActionMap(["OkCancelActions", "DirectionActions", "MovieSelectionActions", "SetupActions"],
		{
			"cancel":	self.exit,
		}, -1)

		self["EPGSelectActions"] = HelpableActionMap(self, "HelpActions",
                {
                        "displayHelp":  self.exit,
                }, -1)

		self["tickermenulist"] = tickerlist([])
		self.onClose.append(self.__onClose)
		self.hidetabTimer_interval = config.plugins.ticker.hidetabTimer.value
		self.verein_farbe = long(config.plugins.ticker.tabfavverinfarbe.value, 16)
		self.myverin = config.plugins.ticker.tabfavverin.value
		#self.liga_url = config.plugins.ticker.select_liga.value
		self.get_table()

	def __onClose(self):
		self.hidetab.stop()

	def get_table(self):
		url = "http://livecenter.zdf.de/fb_mbl/feed/s2012/md5/dpa/onl1.xml?_"
		load = getPage(url, timeout=15)
		load.addCallback(self.get_data)
		load.addErrback(self.errorload)

	def get_data(self, data):
		self.tickermenulist = []
		#tab = re.findall('<td class="btColPosition".*?([0-9]|[0-9][0-9])</td>.*?<td class="btColMannschaft">(.*?)</td>.*?<td class="btColSpiele">(.*?)</td>.*?<td class="btColTore">(.*?)</td>.*?<td class="btColPunkte">(.*?)</td>', data, re.S)
		tab = re.findall('<team teamId="(.*?)".*?<rank>(.*?)</rank>.*?<gamesPlayed>(.*?)</gamesPlayed>.*?<goals>(.*?)</goals>.*?<goalsConceded>(.*?)</goalsConceded>.*?<points>(.*?)</points>', data, re.S)
		for each in tab:
			(teamid, rank, gamesplayed, goals, goalsconceded, points) = each
			diff = "%s:%s" % (goals, goalsconceded)
			self.tickermenulist.append(self.bulitab(rank, self.id_to_teamname(teamid), gamesplayed, diff, points))
		self["tickermenulist"].l.setList(self.tickermenulist)
		self["tickermenulist"].l.setItemHeight(20)
		self["tickermenulist"].selectionEnabled(0)

	def bulitab(self, platz, verein, tore, diff, punkte):
		if config.plugins.ticker.hidetabTimerOnOff.value == "1":
			self.hidetab.start(self.hidetabTimer_interval)
		res = [ (platz, verein, tore, diff, punkte) ]
		#print platz, verein, tore, diff, punkte
		champ = "/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/up.png"
		anstieg = "/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/down.png"
		if platz in ('1', '2', '3'):
			res.append(MultiContentEntryPixmapAlphaTest(pos=(4, 3), size=(20, 20), png=loadPNG(champ)))
		elif platz in ('16', '17', '18'):
			res.append(MultiContentEntryPixmapAlphaTest(pos=(4, 4), size=(20, 20), png=loadPNG(anstieg)))
		if int(platz) < 10:
			platz = "%s." % platz
			res.append(MultiContentEntryText(pos=(42, 0), size=(40, 20), font=8, text=platz, flags=RT_HALIGN_LEFT))
		else:
			platz = "%s." % platz
			res.append(MultiContentEntryText(pos=(30, 0), size=(40, 20), font=8, text=platz, flags=RT_HALIGN_LEFT))
		if self.transHTML(verein) == self.myverin:
			res.append(MultiContentEntryText(pos=(70, 0), size=(200, 20), font=8, color=self.verein_farbe, text=self.transHTML(verein), flags=RT_HALIGN_LEFT))
		else:
			res.append(MultiContentEntryText(pos=(70, 0), size=(200, 20), font=8, text=self.transHTML(verein), flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(290, 0), size=(40, 20), font=8, text=tore, flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(340, 0), size=(60, 20), font=8, text=diff, flags=RT_HALIGN_LEFT))
		res.append(MultiContentEntryText(pos=(420, 0), size=(40, 20), font=8, text=punkte, flags=RT_HALIGN_LEFT))
		return res

	def id_to_teamname(self, id):
		id = id.replace('t157','Dortmund').replace('t156','FC Bayern').replace('t167','Schalke 04').replace('t683','M\'Gladbach')
		id = id.replace('t164','Bayer 04').replace('t169','Stuttgart').replace('t808','Hannover 96').replace('t172','Wolfsburg')
		id = id.replace('t171','Bremen').replace('t684','Nuernberg').replace('t1902','Hoffenheim').replace('t160','Freiburg')
		id = id.replace('t810','Mainz 05').replace('t1772','Augsburg').replace('t161','Hamburger SV').replace('t812','Gr. Fuerth')
		id = id.replace('t159','Frankfurt').replace('t1738','Duesseldorf')
		return id
		
	def errorload(self, error):
		print "[ticker] Please report: %s" % str(error)

	def exit(self):
		print "[ticker] table closed."
		self.close()

	def transHTML(self, text):
		text = text.replace('&nbsp;'," ").replace('&#39;',"'").replace('&szlig;',".").replace('&quot;','"').replace('&ndash;',"-")
		text = text.replace('&copy;.*'," ").replace('&amp;',"&").replace('&uuml;',"ü").replace('&auml;',"ä").replace('&ouml;',"ö")
		text = text.replace('&Uuml;',".").replace('&Auml;',".").replace('&Ouml;',".")
		text = text.replace('',"ae").replace('',"oe").replace('',"ue")
		return text
			
class tickertime(Screen):
	if getDesktop(0).size().width() == 1280:
		raw_skin = """
			<screen position="{screen.position}" size="1240,82" title="Liga Ticker" transparent="0" flags="wfNoBorder" >
				<widget name="tickermenulist" position="5,0" size="1100,60" transparent="0" scrollbarMode="showNever" />
				<widget name="ticker" position="5,60" size="1200,20" zPosition="0" font="Regular;19" transparent="1" foregroundColor="%s" />
				<widget name="poster" position="1110,0" size="70,70" alphatest="on" />
			</screen>""" % config.plugins.ticker.live_farbe.value

	def __init__(self, session, args=0):
		self.session = session
		tickerpos_x = config.plugins.ticker.tickerpos_x.value
		tickerpos_y = config.plugins.ticker.tickerpos_y.value
		self.tor_farbe = long(config.plugins.ticker.farbe.value, 16)
		self.tor_farbe_neu = long(config.plugins.ticker.farbe_neu.value, 16)
		self.live_spiel = long(config.plugins.ticker.live_spiel.value, 16)
		print self.tor_farbe
		self.dict = {
											'screen.position': "%i,%i"%(tickerpos_x,tickerpos_y),
										}
		self.skin = applySkinVars(tickertime.raw_skin,self.dict)
		print "[ticker] pos: %s, %s" % (tickerpos_x,tickerpos_y)
		Screen.__init__(self, session)
		#self.servicelist = servicelist
		self.updateTimer = eTimer()
		self.updateTimer.callback.append(self.getdata)
		self.hideTimer = eTimer()
		self.hideTimer.callback.append(self.autohideNow)
		self.onLayoutFinish.append(self.layoutFinished)
		self.livegame = False
		
		#self["actions"] = ActionMap(["OkCancelActions", "DirectionActions", "MovieSelectionActions", "SetupActions"],
		self["actions"] = ActionMap(["ColorActions","OkCancelActions","DirectionActions","HelpActions","MovieSelectionActions","InputActions","InfobarActions","InfobarTeletextActions","ChannelSelectBaseActions"],
		{
		"cancel":self.exit,
		#"green":self.getdata,
		"showEventInfo":self.verstecken,
		"showEventView":self.verstecken,
		"contextMenu": self.configScreen,
		#"right": self.pageDown,
		#"left": self.pageUp,
		"up": self.up,
		"down": self.down,
		#"1": self.switch,
		#"2": self.switch,
		#"showMovies": self.switch,
		}, -1)
		
		self["EPGSelectActions"] = HelpableActionMap(self, "HelpActions",
		{
			"displayHelp":	self.tabi,
		}, -1)

		self["ticker"] = Label("")
		self["ticker"].setText("")
		self["poster"] = Pixmap()
		self["poster"].hide()
		self.list_ticker = []
		self.list_tore = []
		self["tickermenulist"] = tickerlist([])
		self.list = []
		self.bdata_alt = []
		self.versteckeninfo = True
		self.firststart = True
		self.update_interval = config.plugins.ticker.refreshtimer.value
		self.hideTimer_interval = config.plugins.ticker.hideTimer.value
		#self.liga_url = config.plugins.ticker.select_liga.value
		self.onClose.append(self.__onClose)

	def switch(self):
		#"bundesliga-ticker" "zweite-liga-ticker"
		print "[Ticker] Switch liga."
		#print config.plugins.ticker.select_liga.value
		if config.plugins.ticker.select_liga.value == "bundesliga-ticker":
			config.plugins.ticker.select_liga.value = "zweite-liga-ticker"
		else:
			config.plugins.ticker.select_liga.value = "bundesliga-ticker"
		config.plugins.ticker.select_liga.save()
		print config.plugins.ticker.select_liga.value
		self.close(self.session, False)

	def up(self):
		print "nun geht es up"
		self.servicelist = self.session.instantiateDialog(ChannelSelection)
		self.servicelist.moveUp()
		self.session.execDialog(self.servicelist)

	def down(self):
		print "nun geht es down"
		self.servicelist = self.session.instantiateDialog(ChannelSelection)
		self.servicelist.moveDown()
		self.session.execDialog(self.servicelist)

#	def pageUp(self):
#		self.servicelist = self.session.instantiateDialog(ChannelSelection)
#		self.servicelist.moveUp()
#		self.servicelist.zap()
#
#	def pageDown(self):
#		self.servicelist = self.session.instantiateDialog(ChannelSelection)
#		self.servicelist.moveDown()
#		self.servicelist.zap()

	def tabi(self):
		self.session.open(tickertab)

	def layoutFinished(self):
		live_farbe = config.plugins.ticker.live_farbe.value
		self["ticker"].instance.setForegroundColor(parseColor(live_farbe))
		self.getdata()

	def __onClose(self):
		print "[ticker] close eTimer."
		self.updateTimer.stop()
		self.hideTimer.stop()

	def verstecken(self):
		if self.versteckeninfo:
			self.hide()
			self.versteckeninfo = False
		else:
			self.show()
			self.versteckeninfo = True
			if config.plugins.ticker.hideTimerOnOff.value == "1":
				#self.hideTimer.start(self.hideTimer_interval)
				self.autohider()
				#print "[ticker] autohider V gestartet time: %s" % self.hideTimer_interval

	def autohider(self):
		#print "gestartet"
		if config.plugins.ticker.hideTimerOnOff.value == "1":
			self.hideTimer.start(self.hideTimer_interval)
			print "[ticker] autohider gestartet time: %s" % self.hideTimer_interval

	def autohideNow(self):
		#print "drin"
		if self.shown:
			print "[ticker] hide ticker NOW."
			self.versteckeninfo = False
			self.hide()
		
	def check_firststart(self):
		if self.firststart:
			print "[ticker] firststart logo."
			self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/ball.png")			
			self.firststart = False
		#else:
		#	print "[ticker] firststart logo - schon da."

	def transHTML(self, text):
		text = text.replace('&nbsp;'," ").replace('&#39;',"'").replace('&szlig;',".").replace('&quot;','"').replace('&ndash;',"-")	
		text = text.replace('&copy;.*'," ").replace('&amp;',"&").replace('&uuml;',"ü").replace('&auml;',"ä").replace('&ouml;',"ö")
		text = text.replace('&Uuml;',".").replace('&Auml;',".").replace('&Ouml;',".")				
		text = text.replace('',"ae").replace('',"oe").replace('',"ue").replace('<br/>','').replace('<b>','').replace('</b>','')
		return text 

	def poster_resize(self, poster_path):
		self["poster"].instance.setPixmap(None)
		self["poster"].hide()
		sc = AVSwitch().getFramebufferScale() # Maybe save during init
		self.picload = ePicLoad()
		size = self["poster"].instance.size()
		self.picload.setPara((size.width(), size.height(), sc[0], sc[1], False, 1, "#00000000")) # Backgroun
		if self.picload.startDecode(poster_path, 0, 0, False) == 0:
			ptr = self.picload.getData()
			if ptr != None:
				print "[ticker] show poster"
				self["poster"].instance.setPixmap(ptr)
				self["poster"].show()
		else:
				print "[ticker] no poster.. error"

	def poster_resize2(self, poster_path):
		self["poster"].instance.setPixmap(None)
		self["poster"].hide()
		sc = AVSwitch().getFramebufferScale() # Maybe save during init
		self.picload = ePicLoad()
		size = self["poster"].instance.size()
		self.picload.setPara((40, 50, sc[0], sc[1], False, 1, "#00000000")) # Backgroun
		if self.picload.startDecode(poster_path, 0, 0, False) == 0:
			ptr = self.picload.getData()
			if ptr != None:
				print "[ticker] show poster"
				self["poster"].instance.setPixmap(ptr)
				self["poster"].show()
		else:
			print "[ticker] no poster.. error"

	def id_to_teamname(self, id):
		id = id.replace('t157','Dortmund').replace('t156','FC Bayern').replace('t167','Schalke 04').replace('t683','M\'Gladbach')
		id = id.replace('t164','Bayer 04').replace('t169','Stuttgart').replace('t808','Hannover 96').replace('t172','Wolfsburg')
		id = id.replace('t171','Bremen').replace('t684','Nuernberg').replace('t1902','Hoffenheim').replace('t160','Freiburg')
		id = id.replace('t810','Mainz 05').replace('t1772','Augsburg').replace('t161','Hamburger SV').replace('t812','Gr. Fuerth')
		id = id.replace('t159','Frankfurt').replace('t1738','Duesseldorf')
		return id

	def tounixtime(self, date_dummy):
		date_tmp = time.strptime(date_dummy, "%Y-%m-%d %H:%M")
		return time.mktime(date_tmp)

	def tonormaltime(self, date_dummy):
		return datetime.fromtimestamp(date_dummy)		
		
	def getdata(self):
		self.updateTimer.stop()
		print "[ticker] starte update."
		url = "http://livecenter.zdf.de/fb_mbl/feed/s2012/md3/dpa/onl1.xml?_="
		print url
		load = getPage(url, timeout=15)
		load.addCallback(self.get_pic_data)
		load.addErrback(self.errorload)

	def get_pic_data(self, data):
		print "[ticker] infos einlesen."
		self.tickermenulist = []
		#infos = re.findall('<fixture.*?date="(.*?)T(.*?):..\+.*?status="(.*?)".*?<teamHome teamId="(.*?)".*?<score total="(.*?)".*?<teamAway teamId="(.*?)".*?<score total="(.*?)"', data, re.S)
		infos = re.findall('<fixture.*?date="(.*?)T(.*?):..\+.*?status="(.*?)".*?<teamHome teamId="(.*?)".*?<score(.*?)/>.*?<teamAway teamId="(.*?)".*?<score(.*?)/>', data, re.S)
		for each in infos:
			(date, uhrzeit, live, home, home_score, away, away_score) = each
			wkday = re.findall('(.*?)-(.*?)-(.*?)$', date)
			dt = datetime(int(wkday[0][0]),int(wkday[0][1]),int(wkday[0][2]))
			teams = "%s - %s" % (self.id_to_teamname(home), self.id_to_teamname(away))
			if re.match('.*?total', home_score, re.S):
				get_home_score = re.findall('total="(.*?)"', home_score)
				get_away_score = re.findall('total="(.*?)"', away_score)
				result = "%s:%s" % (get_home_score[0], get_away_score[0])
			else:
				result = "-:-"
			coming = self.tounixtime("%s %s" % (date, uhrzeit))
			if time.time() > int(coming):
				print teams, result, live
				bdata = teams, result, live
			else:
				uhrzeit = "%s %s" % (dt.strftime('%a'), uhrzeit)
				print teams, uhrzeit, live
				bdata = teams, uhrzeit, live
				
			self.list_tore.append(bdata)
			
		self.list_tore.reverse()	
		self.tickermenulist.append(self.buliticker(self.list_tore))
		self["tickermenulist"].l.setList(self.tickermenulist)
		self["tickermenulist"].l.setItemHeight(60)
		self["tickermenulist"].selectionEnabled(0)
		
		self.check_firststart()
		self.check_live_games()
		
		if self.livegame:
			url = "http://livecenter.zdf.de/fb_mbl/feed/s2012/md2/de/dpa/onl1.xml"
			load = getPage(url, timeout=15)
			load.addCallback(self.spiele_infos)
			load.addErrback(self.errorload)
		else:
			self.updateTimer.start(self.update_interval)
			
	def spiele_infos(self, data):
		if config.plugins.ticker.live_tore.value == "1" and self.livegame:
			tor = re.findall('<event eventId=".*?" messageId=".*?" typId="4" min=".*?" teamId=".*?<text><\!\[CDATA\[(.*?)\]\]></text>', data, re.S)
			if tor:	
				tor.reverse()
				for each in tor:
					if not each in self.list_ticker:
						self.list_ticker.append(each)
						if self.shown:
							print "[ticker] tickerleiste AN."
							print self.transHTML(each)
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/tor.png")
							self.autohider()
						else:
							print "[ticker] tickerleiste AUS -> STARTEN."
							self.verstecken()
							print self.transHTML(each)
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/tor.png")
			else:
				if self.shown:
					self.autohider()

		if config.plugins.ticker.live_karten.value == "1" and self.livegame:
			karten = re.findall('<event eventId=".*?" messageId=".*?" typId="8" min=".*?" teamId=".*?<text><\!\[CDATA\[(.*?)\]\]></text>', data, re.S)
			if karten:
				karten.reverse()
				for each in karten:
					if not each in self.list_ticker:
						self.list_ticker.append(each)					
						if self.shown:
							print "[ticker] tickerleiste AN."
							print each
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/faul.png")
							self.autohider()
						else:
							print "[ticker] tickerleiste AUS -> STARTEN."
							self.verstecken()
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/faul.png")

					#else:
						#print "[ticker] karte bereits vorhanden."

		if config.plugins.ticker.live_wechsel.value == "1" and self.livegame:
			wechsel = re.findall('<event eventId=".*?" messageId=".*?" typId="11" min=".*?" teamId=".*?<text><\!\[CDATA\[(.*?)\]\]></text>', data, re.S)
			if wechsel:
				wechsel.reverse()
				for each in wechsel:
					if not each in self.list_ticker:
						self.list_ticker.append(each)
						if self.shown:
							print "[ticker] tickerleiste AN."
							print each
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/wechsel.png")
							self.autohider()
						else:
							print "[ticker] tickerleiste AUS -> STARTEN."
							self.verstecken()
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/wechsel.png")
					#else:
						#print "[ticker] wechsel bereits vorhanden."

		if config.plugins.ticker.live_halb.value == "1" and self.livegame:
			halb = re.findall('<event eventId=".*?" messageId=".*?" typId="3" min=".*?" teamId=".*?<text><\!\[CDATA\[(.*?)\]\]></text>', data, re.S)
			if halb:
				halb.reverse()
				for each in halb:
					if not each in self.list_ticker:
						self.list_ticker.append(each)
						if self.shown:
							print "[ticker] tickerleiste AN."
							print each
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/halb.png")
							self.autohider()
						else:
							print "[ticker] tickerleiste AUS -> STARTEN."
							self.verstecken()
							self["ticker"].setText(self.transHTML(each))
							self.poster_resize("/usr/lib/enigma2/python/Plugins/Extensions/ticker/images/halb.png")
					#else:
						#print "[ticker] halbzeit bereits vorhanden."

		self.updateTimer.start(self.update_interval)

	def check_live_games(self):
		url = "http://livecenter.zdf.de/fb_mbl/feed/s2012/md2/de/dpa/onl1.xml"
		load = getPage(url, timeout=15)
		load.addCallback(self.check_live_games_data)
		load.addErrback(self.errorload)		
		
	def check_live_games_data(self, data):
		lives = re.findall('<fixture eventId=".*?" status="(.*?)"', data, re.S)
		print lives
		if "LIVE" in lives:
			self.livegame = True
			print "[ticker] Live-Status:", self.livegame
		else:
			self["ticker"].setText("Es wurden noch keine Spiele angepfiffen..")
			self.livegame = False
			print "[ticker] Live-Status:", self.livegame
					
	def errorload(self, error):
		print "[Liga Ticker] Please report: %s" % str(error)

	def download_face(self, face_store, data=""):
		if os.path.exists(face_store):
			print "gedownloadet........"
			self.poster_resize2(face_store)

	def exit(self):
		print "[Liga Ticker] closed."
		#del self.picload
		self.close(self.session, True)

	def configScreen(self):
		self.session.openWithCallback(self.configClose,BulitickerConfigScreen)

	def configClose(self, result):
		if result:
			tickerpos_x = config.plugins.ticker.tickerpos_x.value
			tickerpos_y = config.plugins.ticker.tickerpos_y.value
			print "[ticker] pos: %s x %s" % (tickerpos_x, tickerpos_y)
			print "[ticker] live farbe: %s" % config.plugins.ticker.live_farbe.value
			self.close(self.session, False)

	def buliticker(self, bdata):
		res = [ (bdata) ]
		#bdata_alt_tmp = bdata[:]
		final_tore = []
		bdata_alt2 = []
		print "[ticker] update infos to tv screen."
		#gelb: color=0x00dab329
		#rot: 0x00FF0000
		#blau: 0x000000FF
		#self.bdata_alt = [["M'gladbach - Hamburg", '1:1 (1:0)', 'False'], ['Stuttgart - Freiburg', '3:1 (2:1)', 'False'], ["Mainz - K'lautern", '4:0 (3:0)', 'False'], ['Koeln - Leverkusen', '0:2 (0:1)', 'False'], ['Wolfsburg - Hoffenheim', '1:2 (0:1)', 'False'], ['Augsburg - Hertha BSC', '3:0 (0:0)', 'False'], ['Bremen - Nuernberg', '0:1 (0:0)', 'False'], ['FC Bayern - Schalke 04', '2:0 (1:0)', 'False'], ['Dortmund - Hannover', '3:1 (1:1)', 'False']]

		if not self.bdata_alt:
			for i in xrange(len(bdata)):
				(teams, tore, live) = bdata.pop()
				check = ("%s %s" % (teams, tore))
				#print "keine alte data da."
				final_tore.append([teams, tore, live, "False"])
		else:
			for each in self.bdata_alt:
				bdata_alt2.append("%s %s %s" % (each[0], each[1], each[2]))
			#print bdata_alt2
			for i in xrange(len(bdata)):
				(teams, tore, live) = bdata.pop()
				check = ("%s %s %s" % (teams, tore, live))
				#print "alte data da."
				#print check, bdata_alt2
				if check in bdata_alt2:
					final_tore.append([teams, tore, live, "False"])
				else:
					final_tore.append([teams, tore, live, "True"])
		#print final_tore
		self.bdata_alt = final_tore[:]
		#self.bdata_alt = final_tore_tmp[:]
		final_tore.reverse()
		for i in xrange(len(final_tore)):
			(teams, tore, live, neu) = final_tore.pop()
			#live = live.replace(' ', '')
			#print teams, tore, live, neu
			if i == 0 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(0, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 0 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(0, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 0), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))					
			elif i == 0 and neu == "True":
				res.append(MultiContentEntryText(pos=(0, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))
			elif i == 1 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(370, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 1 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(370, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 0), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 1 and neu == "True":
				res.append(MultiContentEntryText(pos=(370, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 2 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(740, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 2 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(740, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 0), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 2 and neu == "True":
				res.append(MultiContentEntryText(pos=(740, 0), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 0), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 3 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(0, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 3 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(0, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 20), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 3 and neu == "True":
				res.append(MultiContentEntryText(pos=(0, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 4 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(370, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 4 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(370, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 20), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 4 and neu == "True":
				res.append(MultiContentEntryText(pos=(370, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 5 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(740, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 5 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(740, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 20), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 5 and neu == "True":
				res.append(MultiContentEntryText(pos=(740, 20), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 20), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 6 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(0, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 6 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(0, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 40), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))	
			elif i == 6 and neu == "True":
				res.append(MultiContentEntryText(pos=(0, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(250, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 7 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(370, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 7 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(370, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 40), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))
			elif i == 7 and neu == "True":
				res.append(MultiContentEntryText(pos=(370, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(620, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))	
			elif i == 8 and neu == "False" and live in "FULL|PRE-MATCH":
				res.append(MultiContentEntryText(pos=(740, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe, flags=RT_HALIGN_LEFT))
			elif i == 8 and neu == "False" and live in "LIVE|HALF-TIME":
				res.append(MultiContentEntryText(pos=(740, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 40), size=(100, 20), font=3, text=tore, color=self.live_spiel, flags=RT_HALIGN_LEFT))
			elif i == 8 and neu == "True":
				res.append(MultiContentEntryText(pos=(740, 40), size=(250, 20), font=3, text=teams, flags=RT_HALIGN_LEFT))
				res.append(MultiContentEntryText(pos=(970, 40), size=(100, 20), font=3, text=tore, color=self.tor_farbe_neu, flags=RT_HALIGN_LEFT))
		return res

def main(session, **kwargs):
	session.openWithCallback(closen,tickertime)

def closen(session, result):
	if not result:
		print "[ticker] screen reload.."
		session.openWithCallback(closen,tickertime)

def Plugins(**kwargs):
	return [
		PluginDescriptor(name="Liga Ticker", description="Bundesliga Live Ticker", where = [PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main),
		PluginDescriptor(name="Liga Ticker", description="Bundesliga Live Ticker", where = [PluginDescriptor.WHERE_PLUGINMENU], fnc=main, icon="plugin.png")
		]
